#ifndef LIST_H
#define LIST_H

typedef int Element;
typedef enum{FALSE, TRUE} Boolean;

typedef struct list_element { 
	Element value;
	struct list_element *next; 
} node;

typedef node *list;

// PRIMITIVE
list emptyList(void);
Boolean empty(list);
Element head(list);
list tail(list);
list cons(Element, list);

// NON PRIMITIVE
void showList(list);
list reverse(list l);

// DEALLOCAZIONE
void dealloc(list l);

#endif